SvgVersion="01.02.05"
SvgEngine="AvrLogger v"$Version" SVG-Engine v"$SvgVersion", : https://www.luenepiet.de/my_avrlogger/main"
SvgPageID="AVRlog"
svgTimeline=0
# ----------------------------------------------------------
# --- Prepare SVG-Values
# --- $1 = ViewBoxScale
# ----------------------------------------------------------
svg_Init()
{
    if [ $LogBase -le 24 ]
        then PageSizeWidht=$(GetValue  "$SvgConf" "PageSizeWidht1")
        else PageSizeWidht=$(GetValue  "$SvgConf" "PageSizeWidht2")
    fi

    PageSizeHeight=$(GetValue "$SvgConf" "PageSizeHeight")
    ViewBoxWidth=$[PageSizeWidht*$1]
    ViewBoxHeight=$[PageSizeHeight*$1]

    BorderEdge=$(GetValue "$SvgConf" "BorderEdge")
    BorderX=$BorderEdge
    BorderY=$BorderEdge
    BorderWidth=$[ViewBoxWidth-(2*BorderEdge)]
    BorderHeight=$[ViewBoxHeight-(2*BorderEdge)]
    # --- Plotting Area ---
    PlotAreaFill=$(GetValue "$SvgConf" "PlotAreaFill")
    # ----------------------------------------
    # --- Prepare Borders
    # ----------------------------------------
    PlotEdgeLeft=$(GetValue   "$SvgConf" "PlotEdgeLeft")
    PlotEdgeRight=$(GetValue  "$SvgConf" "PlotEdgeRight")
    PlotEdgeTop=$(GetValue    "$SvgConf" "PlotEdgeTop")
    PlotEdgeBottom=$(GetValue "$SvgConf" "PlotEdgeBottom")

    PlotLabelWidth=$(GetValue  "$SvgConf" "PlotLabelWidth")
    PlotLabelHeight=$(GetValue "$SvgConf" "PlotLabelHeight")

    pw_l=0; pw_r=0; pw_v=0
    if [ "$(GetValue "$SvgConf" "PriLabelOn")" == "Yes" ]; then PlotEdgeLeft=$[PlotEdgeLeft+PlotLabelWidth]; pw_l=PlotLabelWidth; fi
    if [ "$(GetValue "$SvgConf" "SecLabelOn")" == "Yes" ]; then PlotEdgeRight=$[PlotEdgeRight+PlotLabelWidth]; pw_r=PlotLabelWidth; fi
    if [ "$(GetValue "$SvgConf" "VerLabelOn")" == "Yes" ]; then PlotEdgeBottom=$[PlotEdgeBottom+PlotLabelHeight]; pw_v=PlotLabelHeight; fi

    LegAlignment=$(GetValue "$SvgConf" "LegAlignment") # Orientation "Hor" (horizontal) "Ver" (vertical)
    LegZeroX=$(GetValue     "$SvgConf" "LegZeroX")     # X-Zero "Left" / "Right"
    LegZeroY=$(GetValue     "$SvgConf" "LegZeroY")     # Y-Zero "Top" / "Bottom"
    LegOffsetX=$(GetValue   "$SvgConf" "LegOffsetX")
    LegOffsetY=$(GetValue   "$SvgConf" "LegOffestY")
    LegTabX=$(GetValue      "$SvgConf" "LegTabX")
    LegTabY=$(GetValue      "$SvgConf" "LegTabY")

    if [ "$(GetValue "$SvgConf" "LegLabelOn")" == "Yes" ]
    then
        if [[ "$LegZeroY" == "Top"    && "$LegAlignment" == "Hor" ]]; then PlotEdgeTop=$[PlotEdgeTop+LegTabY+(LegOffsetY/2)]; fi
        if [[ "$LegZeroY" == "Bottom" && "$LegAlignment" == "Hor" ]]; then PlotEdgeBottom=$[PlotEdgeBottom+LegTabY+(2*LegOffsetY)]; fi
        if [[ "$LegZeroX" == "Left"   && "$LegAlignment" == "Ver" ]]; then PlotEdgeLeft=$[PlotEdgeLeft+LegTabX+(2*LegOffsetX)]; fi
        if [[ "$LegZeroX" == "Right"  && "$LegAlignment" == "Ver" ]]; then PlotEdgeRight=$[PlotEdgeRight+LegTabX+(2*LegOffsetX)]; fi
        if [  "$LegZeroX" == "Left" ]; then LegLabelAnchor="start"; fi
        if [  "$LegZeroX" == "Right" ]; then LegLabelAnchor="end"; fi
    else
        LegLabelAnchor="start"
    fi

    pw=$[ViewBoxWidth-PlotEdgeLeft-PlotEdgeRight]
    ph=$[ViewBoxHeight-PlotEdgeTop-PlotEdgeBottom]
}

svg_SVG()
{
    lib_TimerStart
    # --- Path to SVG-Plot
    AvrSvg="${userDir}tmp/tmp.svg"
    SvgGraph="${userDir}tmp/graph.tmp"
    # ----------------------------------------
    # --- Prepare SVG
    # ----------------------------------------
    # --- Copy SvgGraph-Template to AvrSvg and overwrite earlier File
    cp "$SvgGraph" "$AvrSvg"

    svg_TimeLabel "Ver" "Verticaly"
    echo -e '\t\t</g> <!-- VerticalAxisEnd -->' >> "$AvrSvg"
    # ----------------------------------------

    Stroke=$(GetValue "$SvgConf" "PlotLineStroke")
    x=$PlotEdgeLeft
    y=$[($PlotEdgeTop+ph)*-1]
    echo -e '\t\t<g id="DataPlots" transform="scale(1,-1) translate('$x','$y')" fill="none" stroke-width="'$Stroke'">'  >> "$AvrSvg"

    # ----------------------------------------
    svg_Plot "Load"     $TabLoad   $TabLoadFlag
    svg_Plot "CPU"      $TabCpu    $TabCpuFlag
    svg_Plot "Status"   $TabStatus $TabStatusFlag
    svg_Plot "Ambiente" $TabEnv    $TabEnvFlag
    svg_Plot "HddMax"   $TabHmax   $TabHmaxFlag
    svg_Plot "HddMin"   $TabHmin   $TabHminFlag
    svg_Plot "HddAvr"   $TabHavr   $TabHavrFlag
    svg_Plot "Pwm"      $TabPwm    $TabPwmFlag
    svg_Plot "i2c"      $Tabi2c    $Tabi2cFlag
    # ----------------------------------------

    echo -e '\t\t</g> <!-- DataPlotsEnd -->' >> "$AvrSvg"
    # ----------------------------------------
    echo -e "\t</g> <!-- PageEnd -->" >> "$AvrSvg"
    echo "</svg> <!-- AvrLoggerEnd -->" >> "$AvrSvg"

	chmod 666 "$AvrSvg"

    # --- Copy "Tempfile" to destination and overwrite earlier File
    # --- ToDo: Copy SVG-File to ../web/ThermalLogger/data/
    cp "$AvrSvg" "$SvgFile"

    # --- Copy "SVG-File" to users defined destination and overwrite earlier File
    SvgCopy=$(GetValue "$LogConf" "SvgCopy")
    if [ ${#SvgCopy} -gt 0 ]; then
        cp "$AvrSvg"  "$SvgCopy"
    fi

    lib_TimerStop
    if [ $1 -eq 0 ]
        then lib_Echo 0 '| SVG: SVG graphic created' "$timerLap |"
        else lib_Echo 0 '| SVG: SVG graphics updated with -'$1'- new values' "$timerLap |"
    fi
}

# ----------------------------------------------------------
# --- Prepare SVG-Header
# --- $1 = ViewBoxScale
# ----------------------------------------------------------
svg_Header()
{
    lib_TimerStart
    # --- Main Values
    lib_PutSvg "$AvrSvg" "SvgEngine" "$SvgEngine"
    lib_PutSvg "$AvrSvg" "SvgPageID" "$SvgPageID"

    lib_PutSvg "$AvrSvg" "PageSizeWidht"  "$PageSizeWidht"
    lib_PutSvg "$AvrSvg" "PageSizeHeight" "$PageSizeHeight"
    lib_PutSvg "$AvrSvg" "ViewBoxWidth"  "$ViewBoxWidth"
    lib_PutSvg "$AvrSvg" "ViewBoxHeight" "$ViewBoxHeight"
    # --- Boarder Values
    lib_CpySvg "$SvgConf" "$AvrSvg" "BorderColor"
    lib_CpySvg "$SvgConf" "$AvrSvg" "BorderStroke"
    lib_CpySvg "$SvgConf" "$AvrSvg" "BorderFill"
    lib_PutSvg "$AvrSvg" "BorderX"      "$BorderX"
    lib_PutSvg "$AvrSvg" "BorderY"      "$BorderY"
    lib_PutSvg "$AvrSvg" "BorderWidth"  "$BorderWidth"
    lib_PutSvg "$AvrSvg" "BorderHeight" "$BorderHeight"

    if [ "$PlotAreaFill" != "none" ]; then
        x1=$PlotEdgeLeft
        y1=$PlotEdgeTop
        x2=$[ViewBoxWidth-PlotEdgeLeft-PlotEdgeRight]
        y2=$[ViewBoxHeight-PlotEdgeTop-PlotEdgeBottom]

        echo -e '\t\t<g id="PlotFrame" fill="'$PlotAreaFill'" stroke="none" stroke-width="1">' >> "$AvrSvg"
        echo -e '\t\t\t<rect x="'$x1'" y="'$y1'" width="'$x2'" height="'$y2'"/>' >> "$AvrSvg"
        echo -e '\t\t</g> <!-- PlotFrameEnd -->' >> "$AvrSvg"
    fi
    # ----------------------------------------
    # --- Legende einfügen
    # ----------------------------------------
    Font=$(GetValue "$SvgConf"   "LegLabelFont")
    Size=$(GetValue "$SvgConf"   "LegLabelSize")
    echo -e '\t\t<g id="Legend" text-anchor="'$LegLabelAnchor'" font-family="'$Font'" font-size="'$Size'" stroke-width="1">' >> "$AvrSvg"
    # ----------------------------------------
    Count=0
    # ----------------------------------------
    svg_Legend "Load"     $TabLoad   $TabLoadFlag
    svg_Legend "CPU"      $TabCpu    $TabCpuFlag
    svg_Legend "Status"   $TabStatus $TabStatusFlag
    svg_Legend "Ambiente" $TabEnv    $TabEnvFlag
    svg_Legend "HddMax"   $TabHmax   $TabHmaxFlag
    svg_Legend "HddMin"   $TabHmin   $TabHminFlag
    svg_Legend "HddAvr"   $TabHavr   $TabHavrFlag
    svg_Legend "Pwm"      $TabPwm    $TabPwmFlag
    svg_Legend "i2c"      $Tabi2c    $Tabi2cFlag
    # ----------------------------------------

    echo -e '\t\t</g> <!-- LegendEnd -->' >> "$AvrSvg"

    lib_TimerStop
    lib_Echo 0 '| SVG: Header created' "$timerLap |"
}

# ----------------------------------------------------------
# --- Draw Grid
# --- $1 = First Name
# --- $2 = Second Name
# --- $3 = Alignment
# ----------------------------------------------------------
svg_Grid()
{
    if [ "$(GetValue "$SvgConf" "$1$2GridOn")" != "Yes" ]; then return; fi

    local Min
    local Max
    local Step
    local Main
    local Color=$(GetValue  "$SvgConf" "$1$2GridColor")
    local Stroke=$(GetValue "$SvgConf" "$1$2GridStroke")
    local Off1=$(GetValue   "$SvgConf" "$1$2GridOff1")
    local Off2=$(GetValue   "$SvgConf" "$1$2GridOff2")
    local Range
    local c=0 a=0 b=0
    local i Inc h x xz yz
    local e_line=""

    if [ "$3" == "h" ]
    then
        Min=$(GetValue    "$SvgConf" "$1Min")
        Max=$(GetValue    "$SvgConf" "$1Max")
        Step=$(GetValue   "$SvgConf" "$1$2Interval")
        Main=$(GetValue   "$SvgConf" "$1MainInterval")
        Range=$[Max-Min]

        Inc=$[(ph*10)/(Range/Step)]
        h=$[Off1+pw+Off2]
        x=$[PlotEdgeLeft-Off1]
        yz=$[(PlotEdgeTop+ph)*10]
    else
        Min=0
        Max=$MaxLines
        Step=$timeStep
        Main=$timeStep
        Range=$MaxLines

        Inc=$[(pw*10)/(Range/Step)]
        h=$[Off1+ph+Off2]
        y=$[PlotEdgeTop-Off1]
        xz=$[PlotEdgeLeft*10]
    fi

    e_line='\t\t\t<g id="'$1$2'Grid" fill="none" stroke-width="'$Stroke'" stroke="'$Color'">\n'
    for (( i=$Min; i <= $Max; i=i+$Step)) do
        if [[ $a -eq $b && "$2" == "Help" ]]
        then
            a=$[a+$Main]
        else
            if [ "$3" == "h" ]
                then y=$[(yz-(Inc*c))/10]
                else x=$[(xz+(Inc*c))/10]
            fi
            e_line+='\t\t\t\t<path d="M'$x','$y' '$3$h'"/>\n'
        fi
        b=$[b+$Step]
        c=$[c+1]
    done
    echo -e "$e_line"'\t\t\t</g> <!-- '$1$2'GridEnd -->' >> "$AvrSvg"
}

# ----------------------------------------------------------
# --- Print Time-Axis Labels
# --- $1 = Name
# --- $2 = ID
# ----------------------------------------------------------
svg_TimeLabel()
{
    if [ "$(GetValue "$SvgConf" "$1LabelOn")" != "Yes" ]; then return; fi

    local Min=0
    local Max=$MaxLines
    local Step=$timeStep
    local Font=$(GetValue   "$SvgConf" "$1LabelFont")
    local Size=$(GetValue   "$SvgConf" "$1LabelSize")
    local Pos=$(GetValue    "$SvgConf" "$1LabelPos")
    local Offset=$(GetValue "$SvgConf" "$1LabelOffset")
    local Anchor=$(GetValue "$SvgConf" "$1LabelAnchor")
    local Suffix=$(GetValue "$SvgConf" "$1LabelSuffix")
    local Range=$MaxLines
    local i Inc x y xz yz
    local c=0 hh m t
    local e_line=""

    e_line='\t\t\t<g id="'$2'Label" text-anchor="'$Anchor'" font-family="'$Font'" font-size="'$Size'">\n'

    Inc=$[(pw*10)/(Range/Step)]
	y=$[PlotEdgeTop+ph+Pos]
    xz=$[PlotEdgeLeft*10]

    svgTimeline=$[$(date +%s)-((PlotRow+1)*LoopTick*arrDiv)]
    t_Step=$[Step*LoopTick*arrDiv]

    for (( i=Min; i <= Max; i=i+Step)) do
        # --- Vertikale Achsenbeschriftung
        t=$[svgTimeline+(c*t_Step)]
        t="$(date -d @"$t" '+%H:%M')"

        x=$[((xz+(Inc*c))/10)-Offset]
		e_line+='\t\t\t\t<text x="'$x'" y="'$y'">'$t$Suffix'</text>\n'
        c=$[c+1]
    done
    echo -e $e_line'\t\t\t</g> <!-- '$2'LabelEnd -->' >> "$AvrSvg"
}

# ----------------------------------------------------------
# --- Print Vertical-Axis Labels
# --- $1 = Name
# --- $2 = ID
# ----------------------------------------------------------
svg_VerLabel()
{
    if [ "$(GetValue "$SvgConf" "$1LabelOn")" != "Yes" ]; then return; fi

    local Min=$(GetValue    "$SvgConf" "$1Min")
    local Max=$(GetValue    "$SvgConf" "$1Max")
    local Step=$(GetValue   "$SvgConf" "$1MainInterval")
    local Font=$(GetValue   "$SvgConf" "$1LabelFont")
    local Size=$(GetValue   "$SvgConf" "$1LabelSize")
    local Pos=$(GetValue    "$SvgConf" "$1LabelPos")
    local Offset=$(GetValue "$SvgConf" "$1LabelOffset")
    local Anchor=$(GetValue "$SvgConf" "$1LabelAnchor")
    local Suffix=$(GetValue "$SvgConf" "$1LabelSuffix")
    local Range=$[Max-Min]
    local i Inc x y xz yz
    local c=0 hh m t
    local e_line=""

    e_line='\t\t\t<g id="'$2'Label" text-anchor="'$Anchor'" font-family="'$Font'" font-size="'$Size'">\n'

    if [ "$1" == "Pri" ]
        then x=$[PlotEdgeLeft-Pos]
        else x=$[PlotEdgeLeft+pw+Pos]
    fi

    Inc=$[(ph*10)/(Range/Step)]
    yz=$[(PlotEdgeTop+ph)*10]

    for (( i=Min; i <= Max; i=i+Step)) do
        y=$[((yz-(Inc*c))/10)+Offset]
        e_line+='\t\t\t\t<text x="'$x'" y="'$y'">'$i' '$Suffix'</text>\n'
        c=$[c+1]
    done
    echo -e $e_line'\t\t\t</g> <!-- '$2'LabelEnd -->' >> "$AvrSvg"
}

# ----------------------------------------------------------
# --- Create Legend of Plot-Sensors
# --- $1 = Plot Name
# --- $2 = Tab ID
# --- $3 = Tab Flag
# ----------------------------------------------------------
svg_Legend()
{
    if [ $3 -eq 0 ]; then return; fi
    if [ "$(GetValue "$SvgConf" "LegLabelOn")" != "Yes" ]; then return; fi
    if [ "$(GetValue "$SvgConf" 'Plot'$1'On')" != "Yes" ]; then return; fi

    Color=$(GetValue "$SvgConf" 'Plot'$1'Color')
    echo -e '\t\t\t<g id="Legend'$1'" fill="'$Color'" stroke="'$Color'">' >> "$AvrSvg"

    # ------------------------------
    if [ "$LegAlignment" == "Hor" ]
        then LegendTab_y=0;        LegendTab_x=$LegTabX;
        else LegendTab_y=$LegTabY; LegendTab_x=0
    fi
    # ------------------------------
    if [ "$LegZeroX" == "Left" ]
    then
        if [ "$LegAlignment" == "Hor" ]
            then LegendZero_x=$[PlotEdgeLeft + LegOffsetX]
            else LegendZero_x=$[PlotEdgeLeft - LegTabX - LegOffsetX - pw_l]
        fi
    else
        LegendTab_x=$[LegendTab_x * -1]
        if [ "$LegAlignment" == "Hor" ]
            then LegendZero_x=$[PlotEdgeLeft + pw - LegTabX - LegOffsetX]
            else LegendZero_x=$[PlotEdgeLeft + pw  + pw_r + LegOffsetX]
        fi
    fi
    # ------------------------------
    if [ "$LegZeroY" == "Top" ]
    then
        if [ "$LegAlignment" == "Hor" ]
            then LegendZero_y=$[PlotEdgeTop - (LegTabY / 2) - LegOffsetY]
            else LegendZero_y=$[PlotEdgeTop + (LegTabY / 2) ] # + LegOffsetY]
        fi
    else
        LegendTab_y=$[LegendTab_y * -1]
        if [ "$LegAlignment" == "Hor" ]
            then LegendZero_y=$[PlotEdgeTop + ph + (LegTabY / 2) + (LegOffsetY * 2) + pw_v]
            else LegendZero_y=$[PlotEdgeTop + ph - (LegTabY / 2) ] # - LegOffsetY]
        fi
    fi
    # ------------------------------

    x=$[LegendZero_x + ( Count * LegendTab_x )]
    y=$[LegendZero_y + ( Count * LegendTab_y )]

    # Signs: Line / Circle / Square
    Sign=$(GetValue "$SvgConf" "LegSign")
    Size=$(GetValue "$SvgConf" "LegSignSize")

    case $Sign in
    	Line)
            h=20; w=$Size
            if [ "$LegZeroX" == "Left" ]
            then
                x1=$x;                y1=$[y-(h/2)]
            else
                x1=$[x+LegTabX-Size]; y1=$[y-(h/2)]
            fi
            echo -e '\t\t\t\t<rect x="'$x1'" y="'$y1'" width="'$w'" height="'$h'"/>' >> "$AvrSvg"
	    ;;
	    Circle)
            h=$[Size/2]
            if [ "$LegZeroX" == "Left" ]
            then
                x1=$[x+h];         y1=$y
            else
                x1=$[x+LegTabX-h]; y1=$y
            fi                
            echo -e '\t\t\t\t<circle cx="'$x1'" cy="'$y1'" r="'$h'"/>' >> "$AvrSvg"
	    ;;
	    Square)
            h=$Size; w=$Size
            if [ "$LegZeroX" == "Left" ]
            then
                x1=$x;             y1=$[y-(h/2)]
            else
                x1=$[x+LegTabX-h]; y1=$[y-(w/2)]
            fi
            echo -e '\t\t\t\t<rect x="'$x1'" y="'$y1'" width="'$w'" height="'$h'"/>' >> "$AvrSvg"
	    ;;
    esac

    Label=$(GetValue      "$SvgConf" 'Plot'$1'Label')
    LabelColor=$(GetValue "$SvgConf" "LegLabelColor")
    Offset=$(GetValue     "$SvgConf" "LegLabelOffset")

    if [ "$LegZeroX" == "Left" ]
    then
        x1=$[x+Size+(Size/2)];         y1=$[y+Offset]
    else
        x1=$[x+LegTabX-Size-(Size/2)]; y1=$[y+Offset]
    fi
    
    echo -e '\t\t\t\t<text fill="'$LabelColor'" stroke="'$LabelColor'" x="'$x1'" y="'$y1'">'$Label'</text>' >> "$AvrSvg"
    echo -e '\t\t\t</g> <!-- Legend'$1'End -->' >> "$AvrSvg"

    Count=$[Count+1]

}

svg_InitPlot()
{
    lib_TimerStart
    # --- Path to SVG-Plot
    AvrSvg="${userDir}tmp/tmp.svg"
    SvgHeader="${workingDir}templates/header.svg"
    SvgGraph="${userDir}tmp/graph.tmp"

    # ----------------------------------------
    # --- Prepare SVG-Header
    # ----------------------------------------
    # --- Copy "Header" to SvgGraph-Template and overwrite earlier File
    cp "$SvgHeader" "$SvgGraph"
    AvrSvg="$SvgGraph"
    svg_Header

    # ----------------------------------------
    echo -e '\t\t<g id="PrimaryAxis">' >> "$AvrSvg"
    svg_Grid "Pri" "Main" "h"
    svg_Grid "Pri" "Help" "h"
    svg_VerLabel "Pri" "Primary"
    echo -e '\t\t</g> <!-- PrimaryAxisEnd -->' >> "$AvrSvg"
    # ----------------------------------------
    echo -e '\t\t<g id="SecondaryAxis">' >> "$AvrSvg"
    svg_Grid "Sec" "Main" "h"
    svg_Grid "Sec" "Help" "h"
    svg_VerLabel "Sec" "Secondary"
    echo -e '\t\t</g> <!-- SecondaryAxisEnd -->' >> "$AvrSvg"
    # ----------------------------------------
    # --- Vertical Axis
    # ----------------------------------------
    echo -e '\t\t<g id="VerticalAxis">' >> "$AvrSvg"
    svg_Grid "Ver" "Main" "v"
    # ----------------------------------------
    lib_TimerStop
    lib_Echo 0 '| SVG: Graph-Template created' "$timerLap |"
}

# ----------------------------------------------------------
# --- Generate Plot-Template
# --- $1 = Name
# --- $2 = TabNumber
# --- $3 = TabFlag
# ----------------------------------------------------------
svg_Plot()
{
    if [[ $3 -eq 0 || $minRowFlag -eq 0 || "$(GetValue "$SvgConf" 'Plot'$1'On')" != "Yes" ]]; then return; fi

    local p=0 i=0 j=0 f=0
    local Color="" line=""

    Color=$(GetValue "$SvgConf" 'Plot'$1'Color')
	echo -e '\t\t\t<polyline id="Plot'$1'" stroke="'$Color'" points="'  >> "$AvrSvg"

    for ((i=0;i<=$PlotRow;i=$[i+10])) do
        line='\t\t\t'

        if [ $[PlotRow-i] -ge 10 ]
            then f=9
            else f=$[PlotRow % 10]
        fi

        for ((j=0;j<=f;j++)) do
            p=$[((i+j)+RowOffset) % MaxLines]
            line+=${plotTime[$[$i+$j]]}","${plotData[$p,$2]}" "
        done

        echo -n -e $line"\n" >> "$AvrSvg"
        
	done

	echo -e '\t\t\t"/> <!-- Plot'$1'End -->' >> "$AvrSvg"
}
