#!/bin/sh
# chmod 755 /usr/local/etc/rc.d/avr_start.sh

workingDir="NEWPATH"
workingName="NEWNAME"
workingERROR="NEWPATH"
workingLOGFILE="NEWPATH"
AvrExecution=0

# --- Check AvrLogger PID
checkPID()
{
    if [ -e "$workingDir$workingName"".pid" ]; then
        AvrPID=`cat "$workingDir$workingName"".pid"`
       	ListPID=`ps -e | grep "$workingName"".sh" | grep -v grep | awk '{print $1;}'`
   	    for PIDEL in $ListPID; do
       	    if [ $PIDEL -eq $AvrPID ]
           	then
               	AvrExecution=1
               	AvrPID=$PIDEL
			    break
           	fi
   	    done
    fi
}

checkPID

case $1 in
    start)
	    if [ $AvrExecution -eq 0 ]
	    then
    		"$workingDir$workingName"".sh" & disown
		    echo "AvrLogger was started in Service-Mode"
    	else
	    	echo "AvrLogger is already running"
	    fi
	    ;;
    stop)
	    if [ $AvrExecution -eq 1 ]; then
		    kill -15 $AvrPID
            if [ -e "$workingDir$workingName"".pid" ]; then rm "$workingDir$workingName"".pid"; fi
		    echo "AvrLogger PID: "$AvrPID" was stopped by System: ShutDown"
    	fi
	    ;;
    status)
        if [ $AvrExecution -eq 0 ]
	    then
	        echo "AvrLogger is not running!"
	        exit 3
	    else
            echo "AvrLogger PID: "$AvrPID" is running."
        fi
        ;;
    update)
	    if [ $AvrExecution -eq 1 ]; then
		    kill -15 $AvrPID
		    sleep 1
        fi
        AvrExecution=0
        checkPID
	    if [ $AvrExecution -eq 0 ]
	    then
    		"$workingDir$workingName"".sh" & disown
		    echo "Update of AvrLogger successfully completed"
    	else
	    	echo "Fatal error: AvrLogger update failed."
	    	exit 1
	    fi
        ;;
    log)
        if [ -e "$workingERROR" ]; then
            if [ $(/bin/wc -l "$workingERROR" | cut -d" " -f1) -ne 0 ]; then
                echo "+-=[ ERROR-Log ]=--------------------------------------------------------------------+"
                /bin/cat "$workingERROR"
            fi
        fi
        if [ -e "$workingLOGFILE" ]; then
            if [ $(/bin/wc -l "$workingLOGFILE" | cut -d" " -f1) -ne 0 ]; then
                echo "+-=[ LOGFILE ]=------------------------------------------------------------------------------------------+"
                /bin/cat "$workingLOGFILE"
            fi
        fi
        ;;
    *) 
        echo "Usage: $0 [start|stop|status|log|update]"
        ;;
esac

exit 0
